import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useEffect, useState } from 'react';
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { usePrefixConfig } from '../root';
import { DTooltip } from '../tooltip';
export function DItem(props) {
    const { children, dId, dLevel, dStep, dSpace, dIcon, dPosinset, dMode, dInNav, dActive, dFocusVisible, dDisabled, onItemClick } = props;
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    const inHorizontalNav = dMode === 'horizontal' && dInNav;
    const _iconMode = dMode === 'icon' && dInNav;
    const [iconMode, setIconMode] = useState(_iconMode);
    useEffect(() => {
        setIconMode(_iconMode);
    }, [_iconMode]);
    const liNode = (_jsxs("li", Object.assign({ id: dId, className: getClassName(`${dPrefix}menu__item`, `${dPrefix}menu__item--basic`, {
            [`${dPrefix}menu__item--horizontal`]: inHorizontalNav,
            [`${dPrefix}menu__item--icon`]: iconMode,
            'is-active': dActive,
            'is-disabled': dDisabled,
        }), style: { paddingLeft: dSpace + dLevel * dStep }, role: "menuitem", "aria-disabled": dDisabled, onClick: onItemClick }, { children: [dFocusVisible && _jsx("div", { className: `${dPrefix}focus-outline` }), _jsx("div", Object.assign({ className: getClassName(`${dPrefix}menu__indicator`, {
                    [`${dPrefix}menu__indicator--first`]: dPosinset[0] === 0 && dPosinset[1] > 1,
                    [`${dPrefix}menu__indicator--last`]: dPosinset[0] === dPosinset[1] - 1 && dPosinset[1] > 1,
                }) }, { children: _jsx("div", { style: { backgroundColor: dLevel === 0 ? 'transparent' : undefined } }) })), checkNodeExist(dIcon) && _jsx("div", Object.assign({ className: `${dPrefix}menu__item-icon` }, { children: dIcon })), _jsx("div", Object.assign({ className: `${dPrefix}menu__item-content` }, { children: children }))] })));
    return iconMode ? (_jsx(DTooltip, Object.assign({ dTitle: children, dPlacement: "right" }, { children: liNode }))) : (liNode);
}
