var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { isNumber, isUndefined, nth } from 'lodash';
import { CheckOutlined, CloseOutlined } from '@react-devui/icons';
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { registerComponentMate, TTANSITION_DURING_BASE } from '../../utils';
import { DCollapseTransition } from '../_transition';
import { DProgress } from '../progress';
import { useComponentConfig, usePrefixConfig } from '../root';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DStepper' });
export function DStepper(props) {
    var _a, _b;
    const _c = useComponentConfig(COMPONENT_NAME, props), { dList, dActive, dPercent, dVertical = false, dIconSize = 36, dLabelBottom = false, dClickable = false, onItemClick } = _c, restProps = __rest(_c, ["dList", "dActive", "dPercent", "dVertical", "dIconSize", "dLabelBottom", "dClickable", "onItemClick"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    const active = (_b = dActive !== null && dActive !== void 0 ? dActive : (_a = nth(dList, 0)) === null || _a === void 0 ? void 0 : _a.step) !== null && _b !== void 0 ? _b : 1;
    return (_jsx("div", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}stepper`, {
            [`${dPrefix}stepper--label-bottom`]: dLabelBottom,
            [`${dPrefix}stepper--vertical`]: dVertical,
            [`${dPrefix}stepper--button`]: dClickable,
        }) }, { children: dList.map((item, index) => {
            const { step: itemStep = index + 1, title: itemTitle, description: itemDescription, icon: itemIcon, status: itemStatus } = item;
            const isCompleted = itemStep < active;
            const isActive = itemStep === active;
            const isWait = itemStep > active;
            const isProgress = isActive && isNumber(dPercent);
            const titleNode = (_jsx("div", Object.assign({ className: `${dPrefix}stepper__step-title`, style: { marginTop: dLabelBottom ? undefined : `calc((${dIconSize}px - 1.1em) / 2)` } }, { children: itemTitle })));
            const separatoreNode = dVertical && dLabelBottom
                ? null
                : index !== dList.length - 1 && (_jsx("div", { className: `${dPrefix}stepper__step-separator`, style: {
                        top: dVertical ? `${dIconSize}px` : `calc((${dIconSize}px - 2px) / 2)`,
                        left: dVertical ? `${dIconSize / 2}px` : dLabelBottom ? `calc(50% + ${dIconSize / 2}px)` : undefined,
                        width: !dVertical && dLabelBottom ? `calc(100% - ${dIconSize}px)` : undefined,
                        height: dVertical ? `calc(100% - ${dIconSize}px)` : undefined,
                    } }));
            return (_jsxs("div", Object.assign({ className: getClassName(`${dPrefix}stepper__step`, isUndefined(itemStatus)
                    ? {
                        'is-completed': isCompleted,
                        'is-active': isActive,
                        'is-wait': isWait,
                    }
                    : {}, {
                    [`is-${itemStatus}`]: itemStatus,
                    [`${dPrefix}stepper__step--last`]: index === dList.length - 1,
                }), style: {
                    maxWidth: !dVertical && index === dList.length - 1 ? `calc(100% / ${dList.length})` : undefined,
                    width: !dVertical && dLabelBottom ? `calc(100% / ${dList.length})` : undefined,
                }, role: dClickable ? 'button' : undefined, tabIndex: dClickable ? 0 : undefined, onKeyDown: (e) => {
                    if (dClickable) {
                        if (e.code === 'Enter' || e.code === 'Space') {
                            e.preventDefault();
                            onItemClick === null || onItemClick === void 0 ? void 0 : onItemClick(itemStep, item);
                        }
                    }
                }, onClick: () => {
                    if (dClickable) {
                        onItemClick === null || onItemClick === void 0 ? void 0 : onItemClick(itemStep, item);
                    }
                } }, { children: [_jsxs("div", Object.assign({ className: `${dPrefix}stepper__step-header` }, { children: [_jsxs("div", Object.assign({ className: getClassName(`${dPrefix}stepper__step-icon`, {
                                    [`${dPrefix}stepper__step-icon--progress`]: isProgress,
                                }), style: {
                                    width: dIconSize,
                                    height: dIconSize,
                                } }, { children: [itemIcon === false ? null : checkNodeExist(itemIcon) ? (itemIcon) : itemStatus === 'error' ? (_jsx(CloseOutlined, {})) : isCompleted ? (_jsx(CheckOutlined, {})) : (itemStep), isProgress && (_jsx(DProgress, { className: `${dPrefix}stepper__step-progress`, dStatus: "process", dPercent: dPercent, dSize: dIconSize + 8, dLineWidth: 2, dType: "circle", dLabel: false }))] })), !dLabelBottom && titleNode, !dVertical && separatoreNode] })), dLabelBottom && titleNode, dVertical && separatoreNode, checkNodeExist(itemDescription) && (_jsx(DCollapseTransition, Object.assign({ dOriginalSize: {
                            height: 'auto',
                        }, dCollapsedStyle: {
                            height: 0,
                        }, dIn: !dVertical || isActive, dDuring: TTANSITION_DURING_BASE, dStyles: {
                            entering: {
                                transition: ['height', 'padding', 'margin'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-out`).join(', '),
                            },
                            leaving: {
                                transition: ['height', 'padding', 'margin'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-in`).join(', '),
                            },
                            leaved: { display: 'none' },
                        } }, { children: (collapseRef, collapseStyle) => (_jsx("div", Object.assign({ ref: collapseRef, className: `${dPrefix}stepper__step-description`, style: Object.assign({ marginLeft: dLabelBottom ? undefined : `calc(${dIconSize}px + 8px)` }, collapseStyle) }, { children: itemDescription }))) })))] }), itemStep));
        }) })));
}
